local T, C, L, _ = unpack(select(2, ...))
if C.chat.enable ~= true then return end

----------------------------------------------------------------------------------------
--	Systems spam filter
----------------------------------------------------------------------------------------
if C.chat.filter == true then
	ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_SAY", function() if IsResting() then return true end end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_YELL", function() if IsResting() then return true end end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_JOIN", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_LEAVE", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_AFK", function() return true end)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_DND", function() return true end)
	DUEL_WINNER_KNOCKOUT = ""
	DUEL_WINNER_RETREAT = ""
	DRUNK_MESSAGE_ITEM_OTHER1 = ""
	DRUNK_MESSAGE_ITEM_OTHER2 = ""
	DRUNK_MESSAGE_ITEM_OTHER3 = ""
	DRUNK_MESSAGE_ITEM_OTHER4 = ""
	DRUNK_MESSAGE_OTHER1 = ""
	DRUNK_MESSAGE_OTHER2 = ""
	DRUNK_MESSAGE_OTHER3 = ""
	DRUNK_MESSAGE_OTHER4 = ""
	DRUNK_MESSAGE_ITEM_SELF1 = ""
	DRUNK_MESSAGE_ITEM_SELF2 = ""
	DRUNK_MESSAGE_ITEM_SELF3 = ""
	DRUNK_MESSAGE_ITEM_SELF4 = ""
	DRUNK_MESSAGE_SELF1 = ""
	DRUNK_MESSAGE_SELF2 = ""
	DRUNK_MESSAGE_SELF3 = ""
	DRUNK_MESSAGE_SELF4 = ""
	ERR_PET_LEARN_ABILITY_S = ""
	ERR_PET_LEARN_SPELL_S = ""
	ERR_PET_SPELL_UNLEARNED_S = ""
	ERR_LEARN_ABILITY_S = ""
	ERR_LEARN_SPELL_S = ""
	ERR_LEARN_PASSIVE_S = ""
	ERR_SPELL_UNLEARNED_S = ""
	CREATED_ITEM = ""
	CREATED_ITEM_MULTIPLE = ""

	-- Prevent empty line
	local function systemFilter(_, _, text)
		if text and text == "" then
			return true
		end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", systemFilter)
end

----------------------------------------------------------------------------------------
--	Players spam filter(by Evl, Elv22 and Affli)
----------------------------------------------------------------------------------------
if C.chat.spam == true then
	-- Repeat spam filter
	local lastMessage, lastSender
	local function repeatMessageFilter(self, event, text, sender, languageName, channelName, playerName2, specialFlags, zoneChannelID, channelIndex, channelBaseName, unused, lineID, guid, bnSenderID, isMobile, isSubtitle, hideSenderInLetterbox, supressRaidIcons)
		if sender == T.name or UnitGUID("player") == guid or UnitIsInMyGuild(sender) then return end
		if not self.repeatMessages or self.repeatCount > 50 then
			self.repeatCount = 0
			self.repeatMessages = {}
		end
		if not self.senders or self.sendCount > 3 then
			self.sendCount = 0
			self.senders = {}
		end
		lastMessage = self.repeatMessages[sender]
		if lastMessage == text then
			return true
		end
		lastSender = self.senders[guid]
		if lastSender == guid then
			return true
		end
		self.repeatMessages[sender] = text
		self.senders[guid] = guid
		self.repeatCount = self.repeatCount + 1
		self.sendCount = self.sendCount + 1
		if specialFlags == "DND" then
    		return true
    	end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", repeatMessageFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", repeatMessageFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", repeatMessageFilter)

	-- Gold/portals spam filter
	local ChatSpam = T.ChatSpamList
	local ChatBlock = T.ChatBlockList
	local function tradeFilter(self, event, text, sender, languageName, channelName, playerName2, specialFlags, zoneChannelID, channelIndex, channelBaseName, unused, lineID, guid)
		if sender == T.name or UnitGUID("player") == guid or UnitIsInMyGuild(sender) then return end
		for _, value in pairs(ChatSpam) do
			if text:lower():match(value) then
				return true
			end
		end
		for _, name in pairs(ChatBlock) do
			if name:len() > 0 and string.find(sender, name) then
				return true
			end
		end	
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", tradeFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", tradeFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", tradeFilter)

	
	if IsAddOnLoaded("ShestakUI_Config") then
		local UnitPopupButtonsExtra = {
	    	["BLOCK"] = { enUS ="Block player",zhCN = "加入屏蔽名单",zhTW = "加入屏蔽名单" },
		}

		for k, v in pairs(UnitPopupButtonsExtra) do
	    	v.text = v[T.client] or k
	    	UnitPopupButtons[k] = v
		end

		tinsert(UnitPopupMenus["FRIEND"], 9, "BLOCK")

		hooksecurefunc("UnitPopup_OnClick", function(self)
	    	local name = UIDROPDOWNMENU_INIT_MENU.name
	    	local IGNORE = format(ERR_IGNORE_ADDED_S,name)
	    	if (self.value == "BLOCK") then
			    if not C.options["chat"] then
					C.options["chat"] = {}
				end	
				if not C.options["chat"]["ChatBlock_list"] then
					C.options["chat"]["ChatBlock_list"] = ChatBlock
				end	
	        	table.insert(C.options.chat.ChatBlock_list, name)
	        	SendSystemMessage(IGNORE)
	    	end
		end)
	end
end
